; Acid11.asm
;  by Jim Macdonell jimm@snowline.net
;
; This simple program prints a list of Monoprotic &
; Polyprotic acids and waits for you to hit the More key to continue. 
; Its modeled after D. Cantrell's "Polyatomic Ion List."  Unfortuately
; he/she didn't post an *.asm file so I actually had to learn TASM from
; scratch. :(
;
; It should work fine on any TI-85. The comments are probably screwed up from
; Copy/Paste-ing.
;
; Always back up the calc memory to the computer before running a new program!
;
; This is my first usefull/successful program so don't expect too much.
;
; Feel free to slaughter or improve this program, just don't distribute
; your "improvements" under my name.



#include "TI-85.h"


.org 0
.db "Mono&Polyprotic Acids v1.1", 0
Start

    ROM_CALL(CLEARLCD)
    
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Name             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $46             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Formula             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

   ;#0 thing done
     
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim1             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

    ld   HL, $48             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim1a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

        
    ;#2 thing done

    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim2             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim2a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


   ;#2 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim3             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim3a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#3 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $1D  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim4             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $1D  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim4a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#4 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $24  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim5             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $24  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim5a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#5 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $2B  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim6             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $2B  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim6a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#6 thing done    
    
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $32  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim7             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $32  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim7a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#7 thing done   
        
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $39  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim8             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $39  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim8a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#8 thing done   
    
    JUMP_(GetLoop)            ; wait for keypress again
Cont
        ROM_CALL(CLEARLCD)
    
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Name             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $46             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Formula             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

   ;#0 thing done
     
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim9             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

    ld   HL, $48             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim9a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

        
    ;#9 thing done

    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim10             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim10a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


   ;#10 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim11             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim11a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#11 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $1D  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim12             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $1D  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim12a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#12 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $24  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim13             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $24  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim13a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#13 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $2B  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim14             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $2B  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim14a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#14 thing done    
    
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $32  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim15             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $32  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim15a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#15 thing done   

             
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $39  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim16             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $39  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim16a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#16 thing done    
    JUMP_(GetLoop1)
Cont2
            ROM_CALL(CLEARLCD)
    
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Name             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $46             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Formula             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

   ;#0 thing done
     
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim17             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

    ld   HL, $48             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim17a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

        
    ;#17 thing done

    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim18             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim18a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


   ;#18 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim19             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim19a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#19 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $1D  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim20             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $1D  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim20a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#20 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $24  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim21             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $24  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim21a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#21 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $2B  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim22             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $2B  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim22a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#22 thing done    
    
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $32  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim23             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $32  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim23a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#23 thing done   

             
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $39  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim24             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $39  
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim24a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#24 thing done 
    JUMP_(GetLoop2)
Cont3    
       ROM_CALL(CLEARLCD)
    
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Name             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $46             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $01       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Formula             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

   ;#0 thing done 
  
    ld   HL, $01             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
     

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim25             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

    ld   HL, $48             ; set text cursor position
    ld   ($8333), HL
    ld   HL, $08       
    ld   ($8334), HL
    

    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim25a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string

        
    ;#25 thing done

    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim26             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $0F
    ld   ($8334), HL 
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim26a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string


   ;#26 thing done
    
    ld   HL, $01            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim27             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    
    ld   HL, $48            ; set text cursor position
    ld   ($8333), HL
    ld   HL, $16  
    ld   ($8334), HL    
    
    ld   HL, (PROGRAM_ADDR) ; get program's memory address
    ld   DE, Jim27a             ; get difference between address of program, string
    add  HL, DE             ; add to get address of string
    ROM_CALL(D_ZM_STR)      ; print the string
    ;#27 thing done   
    JUMP_(GetLoop3)
Cont4    
    ret
GetLoop:                    ; wait for keypress 
    call GET_KEY 
    CP   $37
    jr   z, Cont4a
    CP   $38 
    jr   z, Conta         ; if no key, try again     
    jr   GetLoop
Conta
    JUMP_(Cont)
Cont2a
    JUMP_(Cont2)
Cont3a
    JUMP_(Cont3)
Cont4a
    JUMP_(Cont4)
GetLoop1:                    ; wait for keypress 
    call GET_KEY
    CP   $37
    jr   z, Cont4a 
    CP   $38 
    jr   z, Cont2a         ; if no key, try again     
    jr   GetLoop1    
GetLoop2:                    ; wait for keypress 
    call GET_KEY
    CP   $37
    jr   z, Cont4a 
    CP   $38 
    jr   z, Cont3a         ; if no key, try again     
    jr   GetLoop2    
GetLoop3:                    ; wait for keypress 
    call GET_KEY
    CP   $37
    jr   z, Cont4a 
    CP   $38 
    jr   z, Cont4a         ; if no key, try again     
    jr   GetLoop3                    
Name
    .db "NAME", 0
Formula
    .db "FORMULA", 0
Jim1: 
    .db "Acetic acid", 0   
Jim1a:
    .db "HC2H3O2", 0 
Jim2:
    .db "Ammonium ion", 0
Jim2a:
    .db "NH4 OX:+1", 0
Jim3: 
    .db "Arsenic acid", 0
Jim3a:
    .db "H3AsO4", 0
Jim4:
    .db "Ascorbic acid", 0
Jim4a:
    .db "H2C6H6O6", 0
Jim5: 
    .db "Benzoic acid", 0
Jim5a: 
    .db "HC7H5O2", 0
Jim6:
    .db "Boric acid", 0
Jim6a:
    .db "H3BO3", 0
Jim7:
    .db "Carbonic acid", 0
Jim7a:
    .db "H2CO3", 0
Jim8:
    .db "Chlorous acid", 0
Jim8a:
    .db "HClO2", 0
Jim9:
    .db "Citric Acid", 0
Jim9a:
    .db "H3C6H5O7", 0
Jim10:
    .db "Formic acid", 0
Jim10a:
    .db "HCO2H", 0
Jim11:
    .db "Hydrated Al(III) ion", 0
Jim11a:
    .db "[AL(H2O)6] OX:+3", 0
Jim12:
    .db "Hydrocyanic acid", 0
Jim12a:
    .db "HCN", 0
Jim13:
    .db "Hydrofluoric acid", 0
Jim13a:
    .db "HF", 0
Jim14:
    .db "Hydrogen sulfate ion", 0
Jim14a:
    .db "HSO4 OX:-1", 0
Jim15:
    .db "Hydrosulfuric acid", 0
Jim15a:
    .db "H2S", 0
Jim16:
    .db "Hypobromous acid", 0
Jim16a:
    .db "HOBr", 0
Jim17:
    .db "Hypochlorous acid", 0
Jim17a:
    .db "HOCl", 0
Jim18:
    .db "Hypoiodous acid", 0
Jim18a
    .db "HOI", 0
Jim19:
    .db "Lactic acid", 0
Jim19a:
    .db "HC3H5O3", 0
Jim20:
    .db "Monocloracetic acid", 0
Jim20a:
    .db "HC2H2ClO2", 0
Jim21:
    .db "Nitrous acid", 0
Jim21a:
    .db "HNO2", 0
Jim22:
    .db "Oxalic acid", 0
Jim22a:
    .db "H2C2O4", 0
Jim23:
    .db "Phenol", 0
Jim23a:
    .db "HOC6H5", 0
Jim24:
    .db "Phosphoric acid", 0
Jim24a:
    .db "H3PO4", 0
Jim25:
    .db "Propanoic acid", 0
Jim25a:
    .db "HC3H5O2", 0
Jim26:
    .db "Sulfuric acid", 0
Jim26a:
    .db "H2SO4", 0
Jim27:
    .db "Sulfurous acid", 0
Jim27a:    
    .db "H2SO3", 0
.end
